
var controller = {
    keyName : {
        left : 'keyLeft',
        right : 'keyRight',
        up : 'keyUp',
        down : 'keyDown',
        alt : 'keyAlt'
    },
    direction : {
        left : 'left',
        right : 'right'
    },
    area : {
        left : {
            index : 0,
            hoverClass : 'tab-focus',
            highlightClass : 'tab-select'
        },
        right : {
            index : 0,
            hoverClass : 'faq-focus'
        }
    },
    currentArea : {
        index : 0,
        direction : ''
    },
    areaContent : {
        highlight : null,
        borderbox : null,
        tab : null,
        qa : null,
        op : null
    },
    currentContentTop : 0,
    log : function(msg){
        try{
            console.log('Web Console: ' + msg);
            Android.log('Web Console: ' + msg);
        }catch(e){
            console.log('Web Console: ' + msg);
        }
    },
    exit : function(){
        var that = this;
        try{
            Android.back();
            that.log('exit web page');
        }catch(e){
            that.log('exit web page exception');
        }
    },
    keyPress : function(keyName){
        var that = this;
        var _currentArea = that.currentArea;
        switch(keyName){
            case that.keyName.left:
                if(_currentArea.direction == that.direction.left){

                }else{
                    //右到左
                    var newArea = {
                        index : that.area[that.direction.left].index,
                        direction : that.direction.left
                    };
                    that.updateArea(newArea);
                    that.updateFocus();
                }
                break;
            case that.keyName.right:
                if(_currentArea.direction == that.direction.right){

                }else{
                    //左到右
                    var newArea = {
                        index : that.area[that.direction.right].index,
                        direction : that.direction.right
                    };
                    that.updateArea(newArea);
                    that.updateFocus();
                }
                break;
            case that.keyName.up:
                if(_currentArea.index == 0){

                }else{

                    var newArea = {
                        index : _currentArea.index-1,
                        direction : _currentArea.direction
                    };
                    if(_currentArea.direction == that.direction.left){
                        that.area[that.direction.right].index = 0;
                        that.currentContentTop = 0;
                        that.areaContent.qa.parent().css('top','0px');
                        that.areaContent.op.parent().css('top','0px');
                        that.areaContent.qa.removeClass(that.area[that.direction.right].hoverClass);
                        that.areaContent.op.removeClass(that.area[that.direction.right].hoverClass);
                    }
                    that.updateArea(newArea);
                    that.updateFocus(that.keyName.up);
                }
                break;
            case that.keyName.down:
                var _size = 0;
                if(_currentArea.direction == that.direction.left){
                    _size = that.areaContent.tab.size();
                }else{
                    if(that.area[that.direction.left].index == 0){
                        _size = that.areaContent.qa.size();
                    } else{
                        _size = that.areaContent.op.size();
                    }
                }
                if(_currentArea.index == _size-1){

                }else{
                    var newArea = {
                        index : _currentArea.index+1,
                        direction : _currentArea.direction
                    };
                    if(_currentArea.direction == that.direction.left){
                        that.area[that.direction.right].index = 0;
                        that.currentContentTop = 0;
                        that.areaContent.qa.parent().css('top','0px');
                        that.areaContent.op.parent().css('top','0px');
                        that.areaContent.qa.removeClass(that.area[that.direction.right].hoverClass);
                        that.areaContent.op.removeClass(that.area[that.direction.right].hoverClass);
                    }
                    that.updateArea(newArea);
                    that.updateFocus(that.keyName.down);
                }
                break;
            case that.keyName.alt:
                that.exit();
                break;
        };
    },
    updateArea : function(currentArea){
        var that = this;
        if(currentArea) {
            that.currentArea = currentArea;
            that.area[that.currentArea.direction].index = that.currentArea.index;
            if(that.currentArea.leftIndex){
                that.area[that.direction.left].index = that.currentArea.leftIndex;
            }
        }
    },
    updateFocus : function(keyName){
        var that = this;
        var _contentWrapper = null;
        var _index = that.area[that.direction.left].index;
        if(_index == 0){
            that.areaContent.qa.parent().css('display','block');
            that.areaContent.op.parent().css('display','none');
            _contentWrapper = that.areaContent.qa;
        }else{
            that.areaContent.qa.parent().css('display','none');
            that.areaContent.op.parent().css('display','block');
            _contentWrapper = that.areaContent.op;
        }
        if(that.currentArea.direction == that.direction.left){
            that.areaContent.tab.removeClass(that.area[that.currentArea.direction].hoverClass);
            that.areaContent.tab.removeClass(that.area[that.currentArea.direction].highlightClass);
            that.areaContent.tab.eq(that.currentArea.index).addClass(that.area[that.currentArea.direction].hoverClass);
            that.areaContent.qa.removeClass(that.area[that.direction.right].hoverClass);
            that.areaContent.op.removeClass(that.area[that.direction.right].hoverClass);
        }else{
            that.areaContent.tab.eq(_index).removeClass(that.area[that.direction.left].hoverClass).addClass(that.area[that.direction.left].highlightClass);
            if(that.area[that.direction.left].index == 0){
                that.areaContent.qa.removeClass(that.area[that.currentArea.direction].hoverClass);
                that.areaContent.qa.eq(that.currentArea.index).addClass(that.area[that.currentArea.direction].hoverClass);
            }else{
                that.areaContent.op.removeClass(that.area[that.currentArea.direction].hoverClass);
                that.areaContent.op.eq(that.currentArea.index).addClass(that.area[that.currentArea.direction].hoverClass);
            }
            //switch(keyName){
            //    case that.keyName.up:
            //        if(that.currentArea.index < _contentWrapper.size()-2) {
            //            that.currentContentTop += (_contentWrapper.eq(that.currentArea.index).height() + 34);
            //            _contentWrapper.parent().css('top', that.currentContentTop + 'px');
            //        }
            //        break;
            //    case that.keyName.down:
            //        if(that.currentArea.index <= _contentWrapper.size()-2) {
            //            that.currentContentTop -= (_contentWrapper.eq(that.currentArea.index - 1).height() + 34);
            //            _contentWrapper.parent().css('top', that.currentContentTop + 'px');
            //        }
            //        break;
            //}
            switch(keyName){
                case that.keyName.down:
                    var H = 550 + -1*that.currentContentTop;
                    var h = 0;
                    for(var i=0; i<=that.currentArea.index; i++){
                        h += (_contentWrapper.eq(i).height() + 34)*1;
                    }
                    if(h > H){
                        that.currentContentTop = (h-(_contentWrapper.eq(that.currentArea.index).height() + 34))*-1;
                        _contentWrapper.parent().css('top', that.currentContentTop + 'px');
                    }
                    break;
                case that.keyName.up:
                    var H = -1*that.currentContentTop + (_contentWrapper.eq(that.currentArea.index).height() + 34);
                    var h = 0;
                    for(var i=0; i<=that.currentArea.index; i++){
                        h += (_contentWrapper.eq(i).height() + 34)*1;
                    }
                    if(h < H){
                        that.currentContentTop = (h-(_contentWrapper.eq(that.currentArea.index).height() + 34))*-1;
                        _contentWrapper.parent().css('top', that.currentContentTop + 'px');
                    }
                    break;
            }
        }
    },
    init : function(_currentArea){
        var that = this;
        if(!_currentArea){
            _currentArea = {index:0,direction:that.direction.left,leftIndex:0};
        }
        that.updateArea(_currentArea);
        that.areaContent.highlight = $('#highlight');
        that.areaContent.borderbox = $('#border_box');
        that.areaContent.tab = $('#tab_content').find('.tab-item');
        that.areaContent.qa = $('#faq_content').find('.faq-item');
        that.areaContent.op = $('#guide_content').find('.faq-item');
        that.updateFocus();
        var size = _currentArea.index;
        if(_currentArea.index == that.areaContent.qa.size()-1 || _currentArea.index == that.areaContent.op.size()-1){
            size = size-1;
        }
        if(!_currentArea.leftIndex){
            for(var i=0; i< size; i++){
                that.currentContentTop += (that.areaContent.qa.eq(i).height() + 34);
            }
            that.currentContentTop *= -1;
            that.areaContent.qa.parent().css('top', that.currentContentTop + 'px');
        } else{
            for(var i=0; i< size; i++){
                that.currentContentTop += (that.areaContent.op.eq(i).height() + 34);
            }
            that.currentContentTop *= -1;
            that.areaContent.op.parent().css('top', that.currentContentTop + 'px');
        }
    },
    setPosition : function(type){
        var that = this;
        var _currentArea = null;
        switch(type){
            case 'Broadcast':
                _currentArea = {index:1,direction:that.direction.right};
                break;
            case 'Network':
                _currentArea = {index:6,direction:that.direction.right};
                break;
            case 'Baiduyun':
                _currentArea = {index:10,direction:that.direction.right};
                break;
            case 'Account':
                _currentArea = {index:9,direction:that.direction.right,leftIndex : 1};
                break;
        };
        that.init(_currentArea);
    },
    start : function(){
        var that = this;
        try{
            var type = Android.getCommonInfo(4);
            that.log('Android.getCommonInfo return ' + type);
            if(type){
                that.setPosition(type);
            }else{
                that.setPosition('');
            }
        }catch(e){
            that.log('Android.getCommonInfo is undefined');
            that.setPosition('');
        }
    }

};
function dispatchKeyEvent(event_type){
    try{
        event_type = parseInt(event_type,10);
        switch(event_type){
            case 1:
                controller.keyPress(controller.keyName.left);
                break;
            case 2:
                controller.keyPress(controller.keyName.up);
                break;
            case 3:
                controller.keyPress(controller.keyName.right);
                break;
            case 4:
                controller.keyPress(controller.keyName.down);
                break;
            case 6:
                controller.keyPress(controller.keyName.alt);
                break;
        };
    }catch(e){
        controller.log('key event undefined');
    }
}
$(document).keydown(function(e){
    var e = event || window.event;
    switch (e.keyCode){
        case 37: controller.keyPress(controller.keyName.left);break;
        case 38: controller.keyPress(controller.keyName.up);break;
        case 39: controller.keyPress(controller.keyName.right);break;
        case 40: controller.keyPress(controller.keyName.down);break;
        case 13: break;
        case 8 : break;
        default :break;
    }
});
//controller.setPosition('Network');
//controller.setPosition('Broadcast');
//controller.setPosition('Baiduyun');
//controller.setPosition('Account');
//controller.setPosition('');
controller.start();

